with Abstract_Ring,Generic_Vectors;

generic

  with package Ring is new Abstract_Ring(<>);
  with package Vectors is new Generic_Vectors(Ring);

package Generic_VecVecs is 

  use Vectors;

  type VecVec is array ( integer range <> ) of Link_to_Vector;
  type Link_to_VecVec is access VecVec;

  procedure Clear ( v : in out VecVec );
  procedure Shallow_Clear ( v : in out Link_to_VecVec );
  procedure Deep_Clear ( v : in out Link_to_VecVec );

  -- DESCRIPTION :
  --   A shallow clear on deallocates the pointers, whereas a deep clear
  --   also releases the content.  By default a clear is always deep.

end Generic_VecVecs;
