with Standard_Integer_Vectors;           use Standard_Integer_Vectors;

package Standard_Integer_Norms is

-- DESCRIPTION :
--   This package defines the norm of an integer vector as the gcd of
--   all its entries.  An integer vector is normalized if its elements
--   are relative prime with respect to each other.

  function gcd ( v : Vector ) return integer;

  -- DESCRIPTION :
  --   Returns the positive gcd(v(v'first),..,v(v'last)).

  procedure Normalize ( v : in out Vector );

  -- DESCRIPTION :
  --   All elements in the vector are divided by gcd(v).

end Standard_Integer_Norms;
