with Standard_Complex_Polynomials;
with Standard_Complex_Laur_Polys;
with Standard_Complex_Poly_Systems;      use Standard_Complex_Poly_Systems;
with Standard_Complex_Laur_Systems;      use Standard_Complex_Laur_Systems;

package Standard_Laur_Poly_Convertors is

-- DESCRIPTION :
--   This package contains routines for converting Laurent polynomials to
--   polynomials with natural exponent vectors by shifting when necessary.

  function Laurent_Polynomial_to_Polynomial
              ( p : Standard_Complex_Laur_Polys.Poly )
              return Standard_Complex_Polynomials.Poly;

  procedure Laurent_Polynomial_to_Polynomial
             ( l : in Standard_Complex_Laur_Polys.Poly;
               t : out Standard_Complex_Laur_Polys.Term;
               p : out Standard_Complex_Polynomials.Poly );

  function Laurent_Polynomial_to_Polynomial
	     ( l : Standard_Complex_Laur_Polys.Poly;
               t : Standard_Complex_Laur_Polys.Term )
             return Standard_Complex_Polynomials.Poly;

  -- DESCRIPTION :
  --   Transforms a Laurent polynomial into an ordinary polynomial
  --   by multiplying by an appropriate monomial t.

  function Laurent_to_Polynomial_System ( p : Laur_Sys ) return Poly_Sys;

  -- DESCRIPTION :
  --   Transforms a Laurent polynomial system into a polynomial system.

end Standard_Laur_Poly_Convertors;
